%array

%{
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "error.h"
#include "qc.h"
%}

DIGIT		[0-9]
VAR		[a-z]
OP		"+"|"-"|"~"|"_"|"<"|">"|"&"|""|""|"*"|"/"|"^"|"!"
OPN		"~"|"_"|"<"|">"|"&"|""|""|"*"|"/"|"^"
OPF		"+"|"-"|"~"|"_"|"<"|">"|"&"|""|""|"*"|"/"|"^"

%{
extern double constant[99], oldresult, presult, user_var[26];
extern int boolset;
extern char command_str[CMD_LENGTH];
extern char *c_prev;
char buffer[15], next;
signed int p_count=0;
int co_index=0;
%}

%%

("-"{3,})			|
{OPF}[ \t]*$			|
^[ \t]*({OPN}|"--")		|
{OPF}[ \t]*")"			|
"("[ \t]*{OPN}			|
{OPF}[ \t]*{OPN}+		|
[0-9.e]+(([ \t])+)[0-9a-z]+	| 
"!"([ \t])*[0-9a-z"("]+	{
  Error( ERSYNTAX );
  return 1;
}

(E|\"|%pi)(E|\"|%pi) {
  Error( ERSYNTAX );
  return 1;
}

{DIGIT}+"."?{DIGIT}*("E"[-+]?)?{DIGIT}*	{
  sprintf( buffer, "%d", ++co_index );
  strcat( command_str, buffer );
  constant[co_index] = atof( yytext );
  next = input();
  if( (next > 96 && next < 123) || next == '(' )
    strcat( command_str, "*" );
  unput(next);
}

{OP} {
  strcat( command_str, yytext );
}

exp|sin|sinh|cos|cosh|tan|tanh|log|fact {
  buffer[0] = yytext[0];
  if (yytext[3] == 'h') 
    buffer[0] -= 32;
  buffer[1] = '\0';
  strcat( command_str, buffer );
}

a(sin|sinh|cos|cosh|tan|tanh) {
  buffer[0] = 'A';
  buffer[1] = yytext[1];
  if (yytext[4] == 'h')
    buffer[1] -= 32;
  buffer[2] = '\0';
  strcat( command_str, buffer );
}

round {
  strcat( command_str, "r" );
}

floor {
  strcat( command_str, "o" );
}

ceil {
  strcat( command_str, "i" );
}

sign {
  strcat( command_str, "g" );
}

sq {
  strcat( command_str, "q" );
}

sqrt {
  strcat( command_str, "Q" );
}

ln {
  strcat( command_str, "n" );
}

abs {
  strcat( command_str, "a" );
}

%e {
  sprintf( buffer, "%d", ++co_index );
  strcat( command_str, buffer );
  constant[co_index] = M_E;
}

%pi {
  sprintf( buffer, "%d", ++co_index );
  strcat( command_str, buffer );
  constant[co_index] = M_PI;
}

"\"" {
  if (boolset) 
    {
      presult = oldresult;
      boolset = 0;
    }
  sprintf( buffer, "%d", ++co_index );
  strcat( command_str, buffer );
  constant[co_index] = presult;
}

"(" {
  p_count++;
  strcat( command_str, "(" );
}

")" {
  p_count--;
  strcat( command_str, ")" );
  next = input();
  if( (next > 96 && next < 123) || next == '(' || (next > 47 && next < 58) )
    strcat( command_str, "*" );
  unput(next);
}

{VAR} {
  sprintf( buffer, "%d", ++co_index );
  strcat( command_str, buffer );
  constant[co_index] = user_var[(yytext[0]-97)];
  next = input();
  if( (next > 96 && next < 123) || next == '(' )
    strcat( command_str, "*" );
  if( next > 47 && next < 58 )
    {
      Error( ERSYNTAX );
      return 1;
    }
unput(next);
}

[ \t]

[;\n\0]	return 0;

. { Error( ERSYNTAX ); break; }

%%

extern char *user_input;
YY_BUFFER_STATE buf;

int parseinput( void ) {
  int typeresult;

  p_count = 0;
  buf = yy_scan_string( user_input );
  typeresult = yylex();
  yy_delete_buffer( buf );
  if( p_count != 0 )
    Error( ERPARENTHESIS );
  if( typeresult != 100 )
    co_index = 0;
  return typeresult;
}

int yywrap(void) {
  return 1;
}
